classification
Title: Where is NoneType in Python 3?
Type: Stage: resolved
Components: Documentation Versions: Python 3.3, Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: docs@python Nosy List: adelfino, docs@python, mpb, r.david.murray, rhettinger
Priority: low Keywords: patch

Created on 2013-10-29 20:31 by mpb, last changed 2020-10-21 18:40 by adelfino. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 22161 open adelfino, 2020-09-08 23:40
Messages (10)
msg201666 - (view) Author: mpb (mpb) Date: 2013-10-29 20:31
types.NoneType seems to have disappeared in Python 3.  This is probably intentional, but I cannot figure out how to test if a variable is of type NoneType in Python 3.

Specifically, I want to write:
assert  type (v) in ( bytes, types.NoneType )

Yes, I could write:
assert  v is None or type (v) is bytes

But the first assert statement is easier to read (IMO).

Here are links to various Python 3 documentation about None:

[1] http://docs.python.org/3/library/stdtypes.html#index-2

[2] http://docs.python.org/3/library/constants.html#None

Link [2] says: "None  The sole value of the type NoneType."  However, NoneType is not listed in the Python 3 documentation index.  (As compared with the Python 2 index, where NoneType is listed.)

[3] http://docs.python.org/3/library/types.html

If NoneType is gone in Python 3, mention of NoneType should probably be removed from link [2].  If NoneType is present in Python 3, the docs (presumably at least one of the above links, and hopefully also the index) should tell me how to use it.

Here is another link:

[4] http://docs.python.org/3/library/stdtypes.html#bltin-type-objects

"The standard module types defines names for all standard built-in types."  (Except <class 'NoneType'> ???)

None is a built-in constant.  It has a type.  If None's type is not considered to be a "standard built-in type", then IMO this is surprising(!!) and should be documented somewhere (for example, at link [4], and possibly elsewhere as well.)

Thanks!
msg201667 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2013-10-29 20:33
How about:

    type(v) in (bytes, type(None))

or:

   isinstance(v, (bytes, type(None))

or:

   v is None or type(v) is bytes

or:

  v is None or isinstance(v, bytes)
msg201670 - (view) Author: mpb (mpb) Date: 2013-10-29 20:49
Of your 4 suggestions, I mentioned #3 and #4 in my post.  They are less readable, IMO.

1 and 2 are nicer, but both have an "extra" set of nested parenthesis.

While I appreciate the suggestions, I submitted this as a documentation bug, because I think I should be able to find these suggestions somewhere in the Python 3 documentation, at one (or more) of the links I included in my bug report.  Also, the Python 3 documentation does mention NoneType, and if NoneType is not part of Python 3, I claim this is an error in the documentation.

And then, there is my personal favorite work-around:

NoneType = type (None)    # only needed once
assert type (v) in ( bytes, NoneType )

Or (perhaps more confusingly, LOL!):

none = type (None)
assert type (v) in ( bytes, none )

isinstance is more confusing because it takes two arguments.  Whenever I use it I have to think, "isinstance" vs "instanceof", which is Python, which is Java?  (And I haven't used Java seriously in years!)  And then I have to think about the order of the arguments (v, cls) vs (cls, v).  type is just simpler than isinstance.
msg201684 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2013-10-29 22:07
See http://www.python.org/dev/peps/pep-0294/ for some background on this.  The unexpected thing is actually that the types module still exists at all in Python3 :)

That said, its documentation could, indeed, use some improvement to address this kind of question.

Searching the python-dev email list for 'NoneType removal types module" turns up some interesting posts, back in the 2.3 days...basically, type(None) is the One True Way to get NoneType :)
msg201702 - (view) Author: mpb (mpb) Date: 2013-10-30 01:17
Regarding http://www.python.org/dev/peps/pep-0294/ ...

Complete removal of the types module makes more sense to me than letting types continue, but removing NoneType from it!

If type(None) is the one_true_way, then the docs should say that, possibly in multiple locations.
msg376613 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2020-09-09 01:09
I would support adding NoneType back to the types module.  Am not sure why it was ever removed.  It has a much reason to exists as types.FunctionType which is a clear, well-named short-cut for "type(lambda :None)".
msg376614 - (view) Author: Andrés Delfino (adelfino) * (Python triager) Date: 2020-09-09 01:32
types.NoneType was removed here: https://github.com/python/cpython/commit/c9543e42330e5f339d6419eba6a8c5a61a39aeca#diff-0f021aec4e35b86a3160d44069dec997

The thing of adding NoneType to types that is somewhat unpleasing to me is that it's named exactly as the actual type. Seems confusing.
msg376620 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2020-09-09 07:37
Thanks for the link.  It looks like NoneType got inadvertently caught up in the sweep of names that had direct synonyms.
msg376667 - (view) Author: Andrés Delfino (adelfino) * (Python triager) Date: 2020-09-09 22:14
ammar2 found this mail mentioning the changes in that commit https://mail.python.org/pipermail/python-dev/2007-November/075386.html

"I've removed the 'new' module from py3k and also removed a lot of types
from the 'types' module in py3k. It only contains types that aren't
easily available through builtins."
msg379228 - (view) Author: Andrés Delfino (adelfino) * (Python triager) Date: 2020-10-21 18:40
As per https://github.com/python/cpython/pull/22336 I believe this issue can be closed now.

My PR is not relevant to the problem stated by OP, so I'm "unlinking" it.
History
Date User Action Args
2020-10-21 18:40:05adelfinosetstatus: open -> closed
resolution: fixed
messages: + msg379228

stage: patch review -> resolved
2020-09-09 22:14:18adelfinosetmessages: + msg376667
2020-09-09 07:37:41rhettingersetmessages: + msg376620
2020-09-09 01:32:52adelfinosetmessages: + msg376614
2020-09-09 01:09:29rhettingersetnosy: + rhettinger
messages: + msg376613
2020-09-08 23:40:37adelfinosetkeywords: + patch
nosy: + adelfino

pull_requests: + pull_request21235
stage: patch review
2013-11-17 13:58:16christian.heimessetpriority: normal -> low
nosy: - christian.heimes

versions: + Python 3.4
2013-10-30 01:17:21mpbsetmessages: + msg201702
2013-10-29 22:07:06r.david.murraysetnosy: + r.david.murray
messages: + msg201684
2013-10-29 20:49:24mpbsetmessages: + msg201670
2013-10-29 20:33:51christian.heimessetnosy: + christian.heimes
messages: + msg201667
2013-10-29 20:31:31mpbcreate